---
title: Element Type
slug: singleconnect-2-16/element-type
description: Learn how to retrieve, manipulate, delete, and update element types using C#, cURL, and JavaScript in this comprehensive REST API documentation. Includes code examples and responses, as well as a sample test element type with properties and possible value
docTags: 
createdAt: 2021-02-26T09:14:28.000Z
---



:::ApiMethodV2
```json
{
  "tab": "examples",
  "url": "http://{{hostname}}/aioc-rest-web/rest/element/loadAll",
  "name": "Get Element Types",
  "method": "GET",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "kd6rn6FdWMYn7MeQgLgWz",
        "code": "[\n    {\n        \"dbId\": -1256593,\n        \"elementTypeId\": \"linux\",\n        \"elementTypeName\": \"Linux Server\",\n        \"vendor\": null,\n        \"category\": null,\n        \"elementTypeProperties\": [\n            {\n                \"dbId\": -328315408,\n                \"elementTypePropertyValue\": \"^Quit.*\",\n                \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.exc_last_line_patterns\",\n                \"elementTypePropertyType\": {\n                    \"displayName\": \"enforcer.terminal.behaviour.exc_last_line_patterns\",\n                    \"allowMultipleValues\": true,\n                    \"valuesPredefined\": false,\n                    \"elementTypePropertyValues\": null,\n                    \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.exc_last_line_patterns\",\n                    \"valueType\": \"REGEX\",\n                    \"encryption\": false\n                }\n            },\n            {\n                \"dbId\": -224107347,\n                \"elementTypePropertyValue\": \".*?(&gt|\\\\$|#|%)\",\n                \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.prompt_pattern\",\n                \"elementTypePropertyType\": {\n                    \"displayName\": \"enforcer.terminal.behaviour.prompt_pattern\",\n                    \"allowMultipleValues\": false,\n                    \"valuesPredefined\": false,\n                    \"elementTypePropertyValues\": null,\n                    \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.prompt_pattern\",\n                    \"valueType\": \"REGEX\",\n                    \"encryption\": false\n                }\n            },\n   {\n        \"dbId\": -123,\n        \"elementTypeId\": \"windows\",\n        \"elementTypeName\": \"Windows\",\n        \"vendor\": null,\n        \"category\": null,\n        \"elementTypeProperties\": [\n            {\n                \"dbId\": 2818341,\n                \"elementTypePropertyValue\": \"true\",\n                \"elementTypePropertyKey\": \"discovery.dns.lookup.hostname\",\n                \"elementTypePropertyType\": {\n                    \"displayName\": \"discovery.dns.lookup.hostname\",\n                    \"allowMultipleValues\": false,\n                    \"valuesPredefined\": true,\n                    \"elementTypePropertyValues\": [\n                        \"true\",\n                        \"false\"\n                    ],\n                    \"elementTypePropertyKey\": \"discovery.dns.lookup.hostname\",\n                    \"valueType\": \"STRING\",\n                    \"encryption\": false\n                }\n            }\n        ]\n    }\n]",
        "language": "200"
      }
    ],
    "selectedLanguageId": "kd6rn6FdWMYn7MeQgLgWz"
  },
  "examples": {
    "languages": [
      {
        "id": "KRWEvoUFTveywrOwi_EWg",
        "code": "var client = new RestClient(\"http://{{hostname}}/aioc-rest-web/rest/element/loadAll\");\r\nclient.Timeout = -1;\r\nvar request = new RestRequest(Method.GET);\r\nrequest.AddHeader(\"Content-Type\", \"application/json\");\r\nIRestResponse response = client.Execute(request);\r\nConsole.WriteLine(response.Content);",
        "language": "csharp"
      },
      {
        "id": "TNVCxHCIoTU781vGaq6d_",
        "code": "curl --location -g --request GET 'http://{{hostname}}/aioc-rest-web/rest/element/loadAll' \\\n--header 'Content-Type: application/json'",
        "language": "curl"
      },
      {
        "id": "CK1MKOpd6DYGYxmzY0F9d",
        "code": "var settings = {\r\n  \"url\": \"http://{{hostname}}/aioc-rest-web/rest/element/loadAll\",\r\n  \"method\": \"GET\",\r\n  \"timeout\": 0,\r\n  \"headers\": {\r\n    \"Content-Type\": \"application/json\"\r\n  },\r\n};\r\n\r\n$.ajax(settings).done(function (response) {\r\n  console.log(response);\r\n});",
        "language": "javascript"
      }
    ],
    "selectedLanguageId": "KRWEvoUFTveywrOwi_EWg"
  },
  "description": " ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  }
}
```
:::



:::ApiMethodV2
```json
{
  "tab": "examples",
  "url": "http://{{hostname}}/aioc-rest-web/rest/element/loadAllElementTypePropertyType",
  "name": "Get All Element Type Property Type",
  "method": "GET",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "q8JfDuHr6GIxriqFIRK4D",
        "code": "[\n    {\n        \"displayName\": \"discovery.commands.hostname.pattern\",\n        \"allowMultipleValues\": false,\n        \"valuesPredefined\": false,\n        \"elementTypePropertyValues\": null,\n        \"elementTypePropertyKey\": \"discovery.commands.hostname.pattern\",\n        \"valueType\": \"REGEX\",\n        \"encryption\": false\n    },\n    {\n        \"displayName\": \"shell.terminal.config.ssh.server.alive.interval\",\n        \"allowMultipleValues\": false,\n        \"valuesPredefined\": false,\n        \"elementTypePropertyValues\": null,\n        \"elementTypePropertyKey\": \"shell.terminal.config.ssh.server.alive.interval\",\n        \"valueType\": \"INT\",\n        \"encryption\": false\n    }\n    ..Continued\n]",
        "language": "200"
      }
    ],
    "selectedLanguageId": "q8JfDuHr6GIxriqFIRK4D"
  },
  "examples": {
    "languages": [
      {
        "id": "N4HT769EGuI8hs_CFv_Xq",
        "code": "var client = new RestClient(\"http://{{hostname}}/aioc-rest-web/rest/element/loadAllElementTypePropertyType\");\r\nclient.Timeout = -1;\r\nvar request = new RestRequest(Method.GET);\r\nrequest.AddHeader(\"Content-Type\", \"application/json\");\r\nIRestResponse response = client.Execute(request);\r\nConsole.WriteLine(response.Content);",
        "language": "csharp"
      },
      {
        "id": "BZps8dCxcf18fUJQazzl3",
        "code": "curl --location -g --request GET 'http://{{hostname}}/aioc-rest-web/rest/element/loadAllElementTypePropertyType' \\\n--header 'Content-Type: application/json'",
        "language": "curl"
      },
      {
        "id": "3QKuj1JSpR5WFmB0DFR7k",
        "code": "var settings = {\r\n  \"url\": \"http://{{hostname}}/aioc-rest-web/rest/element/loadAllElementTypePropertyType\",\r\n  \"method\": \"GET\",\r\n  \"timeout\": 0,\r\n  \"headers\": {\r\n    \"Content-Type\": \"application/json\"\r\n  },\r\n};\r\n\r\n$.ajax(settings).done(function (response) {\r\n  console.log(response);\r\n});",
        "language": "javascript"
      }
    ],
    "selectedLanguageId": "N4HT769EGuI8hs_CFv_Xq"
  },
  "description": " ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  }
}
```
:::



:::ApiMethodV2
```json
{
  "tab": "examples",
  "url": "http://{{hostname}}/aioc-rest-web/rest/element/saveElementType",
  "name": "Save Element Type",
  "method": "POST",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "-VqR60hKpKD_7qjoM6jXJ",
        "code": "{\n    \"dbId\": 4017508,\n    \"elementTypeId\": \"test_element_type\",\n    \"elementTypeName\": \"Test Element Type\",\n    \"vendor\": null,\n    \"category\": null,\n    \"elementTypeProperties\": [\n        {\n            \"dbId\": 4017509,\n            \"elementTypePropertyValue\": \"do_nothing\",\n            \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_z\",\n            \"elementTypePropertyType\": {\n                \"displayName\": \"enforcer.terminal.behaviour.ctrl_z\",\n                \"allowMultipleValues\": false,\n                \"valuesPredefined\": true,\n                \"elementTypePropertyValues\": [\n                    \"DO_NOTHING\",\n                    \"ABORT_AND_GO_TO_ROOT\",\n                    \"EXECUTE_AND_GO_TO_ROOT\"\n                ],\n                \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_z\",\n                \"valueType\": \"STRING\",\n                \"encryption\": false\n            }\n        }\n    ]\n}",
        "language": "200"
      }
    ],
    "selectedLanguageId": "-VqR60hKpKD_7qjoM6jXJ"
  },
  "examples": {
    "languages": [
      {
        "id": "CbrNrJvtaj1no-RA6Ujkl",
        "code": "var client = new RestClient(\"http://{{hostname}}/aioc-rest-web/rest/element/saveElementType\");\r\nclient.Timeout = -1;\r\nvar request = new RestRequest(Method.POST);\r\nrequest.AddHeader(\"Content-Type\", \"application/json\");\r\nrequest.AddParameter(\"application/json\", \"{\\n    \\\"elementTypeId\\\": \\\"test_element_type\\\",\\n    \\\"elementTypeName\\\": \\\"Test Element Type\\\",\\n    \\\"vendor\\\": null,\\n    \\\"category\\\": null,\\n    \\\"elementTypeProperties\\\": [\\n        {\\n            \\\"elementTypePropertyValue\\\": \\\"do_nothing\\\",\\n            \\\"elementTypePropertyKey\\\": \\\"enforcer.terminal.behaviour.ctrl_z\\\"\\n        }\\n    ]\\n}\",  ParameterType.RequestBody);\r\nIRestResponse response = client.Execute(request);\r\nConsole.WriteLine(response.Content);",
        "language": "csharp"
      },
      {
        "id": "Y37u01sQbuLBEFI6R6-f3",
        "code": "curl --location -g --request POST 'http://{{hostname}}/aioc-rest-web/rest/element/saveElementType' \\\n--header 'Content-Type: application/json' \\\n--data-raw '{\n    \"elementTypeId\": \"test_element_type\",\n    \"elementTypeName\": \"Test Element Type\",\n    \"vendor\": null,\n    \"category\": null,\n    \"elementTypeProperties\": [\n        {\n            \"elementTypePropertyValue\": \"do_nothing\",\n            \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_z\"\n        }\n    ]\n}'",
        "language": "curl"
      },
      {
        "id": "r8uCA8aCyT9LroCLcRaws",
        "code": "var settings = {\r\n  \"url\": \"http://{{hostname}}/aioc-rest-web/rest/element/saveElementType\",\r\n  \"method\": \"POST\",\r\n  \"timeout\": 0,\r\n  \"headers\": {\r\n    \"Content-Type\": \"application/json\"\r\n  },\r\n  \"data\": JSON.stringify({\"elementTypeId\":\"test_element_type\",\"elementTypeName\":\"Test Element Type\",\"vendor\":null,\"category\":null,\"elementTypeProperties\":[{\"elementTypePropertyValue\":\"do_nothing\",\"elementTypePropertyKey\":\"enforcer.terminal.behaviour.ctrl_z\"}]}),\r\n};\r\n\r\n$.ajax(settings).done(function (response) {\r\n  console.log(response);\r\n});",
        "language": "javascript"
      }
    ],
    "selectedLanguageId": "CbrNrJvtaj1no-RA6Ujkl"
  },
  "description": " ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  }
}
```
:::



:::ApiMethodV2
```json
{
  "tab": "examples",
  "url": "http://{{hostname}}/aioc-rest-web/rest/element/removeElementType",
  "name": "Delete Element Type",
  "method": "POST",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "u0UfXhnZKgAhuHwT0zG1U",
        "code": "{\n  \"dbId\": 927\n}",
        "language": "200"
      }
    ],
    "selectedLanguageId": "u0UfXhnZKgAhuHwT0zG1U"
  },
  "examples": {
    "languages": [
      {
        "id": "2kkA1HfzTdQqLsKZZan1P",
        "code": "var client = new RestClient(\"http://{{hostname}}/aioc-rest-web/rest/element/removeElementType\");\r\nclient.Timeout = -1;\r\nvar request = new RestRequest(Method.POST);\r\nrequest.AddHeader(\"Content-Type\", \"application/json\");\r\nrequest.AddParameter(\"application/json\", \"{\\n    \\\"dbId\\\": 927\\n}\",  ParameterType.RequestBody);\r\nIRestResponse response = client.Execute(request);\r\nConsole.WriteLine(response.Content);",
        "language": "csharp"
      },
      {
        "id": "gapkSdGV7DSjVBYsQ5pUP",
        "code": "curl --location -g --request POST 'http://{{hostname}}/aioc-rest-web/rest/element/removeElementType' \\\n--header 'Content-Type: application/json' \\\n--data-raw '{\n    \"dbId\": 927\n}'",
        "language": "curl"
      },
      {
        "id": "U-Ebex18yttOck8cL0k42",
        "code": "var settings = {\r\n  \"url\": \"http://{{hostname}}/aioc-rest-web/rest/element/removeElementType\",\r\n  \"method\": \"POST\",\r\n  \"timeout\": 0,\r\n  \"headers\": {\r\n    \"Content-Type\": \"application/json\"\r\n  },\r\n  \"data\": JSON.stringify({\"dbId\":927}),\r\n};\r\n\r\n$.ajax(settings).done(function (response) {\r\n  console.log(response);\r\n});",
        "language": "javascript"
      }
    ],
    "selectedLanguageId": "2kkA1HfzTdQqLsKZZan1P"
  },
  "description": " ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  }
}
```
:::



:::ApiMethodV2
```json
{
  "tab": "examples",
  "url": "http://{{hostname}}/aioc-rest-web/rest/element/removeMultiElementType",
  "name": "Delete Multiple  ElementTypes",
  "method": "POST",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "HgjRUgY6PgrwjE7-foPyt",
        "code": "[\n    {\n        \"dbId\": 930\n    },\n    {\n        \"dbId\": 932\n    }\n]",
        "language": "200"
      }
    ],
    "selectedLanguageId": "HgjRUgY6PgrwjE7-foPyt"
  },
  "examples": {
    "languages": [
      {
        "id": "N0byGP3rgCHWYrNQV145c",
        "code": "var client = new RestClient(\"http://{{hostname}}/aioc-rest-web/rest/element/removeMultiElementType\");\r\nclient.Timeout = -1;\r\nvar request = new RestRequest(Method.POST);\r\nrequest.AddHeader(\"Content-Type\", \"application/json\");\r\nrequest.AddParameter(\"application/json\", \"[\\n    {\\n        \\\"dbId\\\": 930\\n    },\\n    {\\n        \\\"dbId\\\": 932\\n    }\\n]\",  ParameterType.RequestBody);\r\nIRestResponse response = client.Execute(request);\r\nConsole.WriteLine(response.Content);",
        "language": "csharp"
      },
      {
        "id": "o_HhWly-OfIMOo0JlIf2q",
        "code": "curl --location -g --request POST 'http://{{hostname}}/aioc-rest-web/rest/element/removeMultiElementType' \\\n--header 'Content-Type: application/json' \\\n--data-raw '[\n    {\n        \"dbId\": 930\n    },\n    {\n        \"dbId\": 932\n    }\n]'",
        "language": "curl"
      },
      {
        "id": "1HQkq7XHFvA8yUFily4li",
        "code": "var settings = {\r\n  \"url\": \"http://{{hostname}}/aioc-rest-web/rest/element/removeMultiElementType\",\r\n  \"method\": \"POST\",\r\n  \"timeout\": 0,\r\n  \"headers\": {\r\n    \"Content-Type\": \"application/json\"\r\n  },\r\n  \"data\": JSON.stringify([{\"dbId\":930},{\"dbId\":932}]),\r\n};\r\n\r\n$.ajax(settings).done(function (response) {\r\n  console.log(response);\r\n});",
        "language": "javascript"
      }
    ],
    "selectedLanguageId": "N0byGP3rgCHWYrNQV145c"
  },
  "description": " ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  }
}
```
:::



:::ApiMethodV2
```json
{
  "tab": "request",
  "url": "http://{{hostname}}/aioc-rest-web/rest/element/saveElementType",
  "name": "Update Element Type",
  "method": "POST",
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [],
    "formDataParameters": []
  },
  "results": {
    "languages": [
      {
        "id": "4IAqkAWaDZknk9RCUH9r_",
        "code": "{\n    \"dbId\": 4017508,\n    \"elementTypeId\": \"test_element_type\",\n    \"elementTypeName\": \"Test Element Type\",\n    \"vendor\": null,\n    \"category\": null,\n    \"elementTypeProperties\": [\n        {\n            \"dbId\": 4017796,\n            \"elementTypePropertyValue\": \"do_nothing\",\n            \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_z\",\n            \"elementTypePropertyType\": {\n                \"displayName\": \"enforcer.terminal.behaviour.ctrl_z\",\n                \"allowMultipleValues\": false,\n                \"valuesPredefined\": true,\n                \"elementTypePropertyValues\": [\n                    \"DO_NOTHING\",\n                    \"ABORT_AND_GO_TO_ROOT\",\n                    \"EXECUTE_AND_GO_TO_ROOT\"\n                ],\n                \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_z\",\n                \"valueType\": \"STRING\",\n                \"encryption\": false\n            }\n        },\n        {\n            \"dbId\": 4017797,\n            \"elementTypePropertyValue\": \"abort\",\n            \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_c\",\n            \"elementTypePropertyType\": {\n                \"displayName\": \"enforcer.terminal.behaviour.ctrl_c\",\n                \"allowMultipleValues\": false,\n                \"valuesPredefined\": true,\n                \"elementTypePropertyValues\": [\n                    \"DO_NOTHING\",\n                    \"ABORT\",\n                    \"ABORT_AND_GO_TO_ROOT\",\n                    \"ABORT_AND_GO_TO_ROOT_WHEN_NO_COMMAND\"\n                ],\n                \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_c\",\n                \"valueType\": \"STRING\",\n                \"encryption\": false\n            }\n        }\n    ]\n}",
        "language": "200"
      }
    ],
    "selectedLanguageId": "4IAqkAWaDZknk9RCUH9r_"
  },
  "examples": {
    "languages": [
      {
        "id": "LVuvgfKlA2EJ6KB2NS_XQ",
        "code": "var client = new RestClient(\"http://{{hostname}}/aioc-rest-web/rest/element/saveElementType\");\r\nclient.Timeout = -1;\r\nvar request = new RestRequest(Method.POST);\r\nrequest.AddHeader(\"Content-Type\", \"application/json\");\r\nrequest.AddParameter(\"application/json\", \"{\\n    \\\"dbId\\\": 920,\\n    \\\"elementTypeId\\\": \\\"test_element_type\\\",\\n    \\\"elementTypeName\\\": \\\"Test Element Type\\\",\\n    \\\"vendor\\\": null,\\n    \\\"category\\\": null,\\n    \\\"elementTypeProperties\\\": [\\n        {\\n            \\\"elementTypePropertyValue\\\": \\\"do_nothing\\\",\\n            \\\"elementTypePropertyKey\\\": \\\"enforcer.terminal.behaviour.ctrl_z\\\"\\n        },\\n        {\\n            \\\"elementTypePropertyValue\\\": \\\"abort\\\",\\n            \\\"elementTypePropertyKey\\\": \\\"enforcer.terminal.behaviour.ctrl_c\\\"\\n        }\\n    ]\\n}\",  ParameterType.RequestBody);\r\nIRestResponse response = client.Execute(request);\r\nConsole.WriteLine(response.Content);",
        "language": "csharp"
      },
      {
        "id": "u7zNe08xtyEMyZzv-jswJ",
        "code": "curl --location -g --request POST 'http://{{hostname}}/aioc-rest-web/rest/element/saveElementType' \\\n--header 'Content-Type: application/json' \\\n--data-raw '{\n    \"dbId\": 920,\n    \"elementTypeId\": \"test_element_type\",\n    \"elementTypeName\": \"Test Element Type\",\n    \"vendor\": null,\n    \"category\": null,\n    \"elementTypeProperties\": [\n        {\n            \"elementTypePropertyValue\": \"do_nothing\",\n            \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_z\"\n        },\n        {\n            \"elementTypePropertyValue\": \"abort\",\n            \"elementTypePropertyKey\": \"enforcer.terminal.behaviour.ctrl_c\"\n        }\n    ]\n}'",
        "language": "curl"
      },
      {
        "id": "pkg61eeuYe_Dn5GM0mZGB",
        "code": "var settings = {\r\n  \"url\": \"http://{{hostname}}/aioc-rest-web/rest/element/saveElementType\",\r\n  \"method\": \"POST\",\r\n  \"timeout\": 0,\r\n  \"headers\": {\r\n    \"Content-Type\": \"application/json\"\r\n  },\r\n  \"data\": JSON.stringify({\"dbId\":920,\"elementTypeId\":\"test_element_type\",\"elementTypeName\":\"Test Element Type\",\"vendor\":null,\"category\":null,\"elementTypeProperties\":[{\"elementTypePropertyValue\":\"do_nothing\",\"elementTypePropertyKey\":\"enforcer.terminal.behaviour.ctrl_z\"},{\"elementTypePropertyValue\":\"abort\",\"elementTypePropertyKey\":\"enforcer.terminal.behaviour.ctrl_c\"}]}),\r\n};\r\n\r\n$.ajax(settings).done(function (response) {\r\n  console.log(response);\r\n});",
        "language": "javascript"
      }
    ],
    "selectedLanguageId": "LVuvgfKlA2EJ6KB2NS_XQ"
  },
  "description": " ",
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  }
}
```
:::

